diff --git a/src/main/java/net/minecraft/client/render/ItemRenderer.java b/src/main/java/net/minecraft/client/render/ItemRenderer.java
index 5045e1200..931d744ea 100644
--- a/src/main/java/net/minecraft/client/render/ItemRenderer.java
+++ b/src/main/java/net/minecraft/client/render/ItemRenderer.java
@@ -1,23 +1,19 @@
 package net.minecraft.client.render;
 
+import net.minecraft.client.entity.player.LocalPlayer;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
-import net.minecraft.client.render.block.model.BlockModelStairs;
-import net.minecraft.client.render.block.model.BlockModelStandard;
-import net.minecraft.client.render.item.model.ItemModel;
-import net.minecraft.client.render.item.model.ItemModelStandard;
 import net.minecraft.core.item.Item;
-import net.minecraft.core.item.block.ItemBlock;
+import net.minecraft.core.item.block.BlockItem;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.entity.player.EntityPlayerSP;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.entity.EntityRenderer;
 import net.minecraft.client.render.entity.PlayerRenderer;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.material.Material;
@@ -25,12 +21,11 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
+import org.lwjgl.opengl.GL12;
 
 import static org.lwjgl.opengl.GL11.GL_ALPHA_TEST;
 import static org.lwjgl.opengl.GL11.GL_BLEND;
 import static org.lwjgl.opengl.GL11.GL_DEPTH_TEST;
-import static org.lwjgl.opengl.GL11.GL_TEXTURE_2D;
-import static org.lwjgl.opengl.GL11.glBindTexture;
 import static org.lwjgl.opengl.GL11.glColor4f;
 import static org.lwjgl.opengl.GL11.glDisable;
 import static org.lwjgl.opengl.GL11.glEnable;
@@ -39,10 +34,10 @@ import static org.lwjgl.opengl.GL11.glPushMatrix;
 
 // Referenced classes of package net.minecraft.src:
 //            RenderBlocks, MapItemRenderer, ItemStack, Block, 
-//            RenderEngine, EntityLiving, Tessellator, EntityPlayer,
+//            RenderEngine, Mob, Tessellator, Player,
 //            RenderHelper, MathHelper, World, Item, 
-//            ItemMap, EntityPlayerSP, RenderManager, RenderPlayer, 
-//            Material, BlockFire, InventoryPlayer
+//            MapItem, LocalPlayer, RenderManager, RenderPlayer,
+//            Material, FireBlock, InventoryPlayer
 
 public class ItemRenderer
 {
@@ -50,19 +45,19 @@ public class ItemRenderer
     public ItemRenderer(Minecraft minecraft)
     {
         itemToRender = null;
-        equippedProgress = 0.0F;
-        prevEquippedProgress = 0.0F;
+        height = 0.0F;
+        oHeight = 0.0F;
         renderBlocksInstance = new RenderBlocks();
-        field_20099_f = -1;
+        lastSlot = -1;
         mc = minecraft;
     }
     public float getEquippedProgress(float partialTick){
-        return prevEquippedProgress + (equippedProgress - prevEquippedProgress) * partialTick;
+        return oHeight + (height - oHeight) * partialTick;
     }
 
     public int getItemColorFromMetadata(Item item, int metadata) {
-        if (item instanceof ItemBlock) {
-            Block block = ((ItemBlock)item).getBlock();
+        if (item instanceof BlockItem) {
+            Block block = ((BlockItem)item).getBlock();
             return BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
         }
         return 0xFFFFFF;
@@ -71,7 +66,7 @@ public class ItemRenderer
     public void renderItemInFirstPerson(float partialTick)
     {
         float equipProgress = getEquippedProgress(partialTick);
-        EntityPlayerSP player = mc.thePlayer;
+        LocalPlayer player = mc.thePlayer;
         float rotationPitch = player.xRotO + (player.xRot - player.xRotO) * partialTick;
         GL11.glPushMatrix();
         GL11.glRotatef(rotationPitch, 1.0F, 0.0F, 0.0F);
@@ -91,7 +86,7 @@ public class ItemRenderer
         	}else if(mc.fullbright) {
         		
         	}else {
-        		brightness = mc.theWorld.getLightBrightness(MathHelper.floor_double(player.x), MathHelper.floor_double(player.y), MathHelper.floor_double(player.z));
+        		brightness = mc.theWorld.getLightBrightness(MathHelper.floor(player.x), MathHelper.floor(player.y), MathHelper.floor(player.z));
         	}
             GL11.glColor4f(brightness, brightness, brightness, 1.0f);
             float f6 = 0.8F;
@@ -101,12 +96,12 @@ public class ItemRenderer
             GL11.glTranslatef(-f18 * 0.3F, MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.4F, -f14 * 0.4F);
             GL11.glTranslatef(0.8F * f6, -0.75F * f6 - (1.0F - equipProgress) * 0.6F, -0.9F * f6);
             GL11.glRotatef(45F, 0.0F, 1.0F, 0.0F);
-            GL11.glEnable(32826 /*GL_RESCALE_NORMAL_EXT*/);
+            GL11.glEnable(GL12.GL_RESCALE_NORMAL);
             f14 = MathHelper.sin(swingProgress * swingProgress * MathHelper.PI);
             f18 = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
             GL11.glRotatef(f18 * 70F, 0.0F, 1.0F, 0.0F);
             GL11.glRotatef(-f14 * 20F, 0.0F, 0.0F, 1.0F);
-            mc.renderEngine.loadDownloadableTexture(mc.thePlayer.skinURL, mc.thePlayer.getEntityTexture(), PlayerSkinParser.instance);
+            mc.renderEngine.bindDownloadableTexture(mc.thePlayer.skinURL, mc.thePlayer.getEntityTexture(), PlayerSkinParser.instance);
             GL11.glTranslatef(-1F, 3.6F, 3.5F);
             GL11.glRotatef(120F, 0.0F, 0.0F, 1.0F);
             GL11.glRotatef(200F, 1.0F, 0.0F, 0.0F);
@@ -118,7 +113,7 @@ public class ItemRenderer
             renderplayer.drawFirstPersonHand(mc.thePlayer, false);
         }
         GL11.glPopMatrix();
-        GL11.glDisable(32826 /*GL_RESCALE_NORMAL_EXT*/);
+        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
         Lighting.disable();
     }
 
@@ -127,16 +122,16 @@ public class ItemRenderer
 		glDisable(GL_ALPHA_TEST);
 		
 		if(mc.thePlayer.isOnFire()) {
-            TextureRegistry.blockAtlas.bindTexture();
+            TextureRegistry.blockAtlas.bind();
 			renderFireInFirstPerson(partialTicks);
 		}
 		
 		if(mc.thePlayer.isInWall() && !mc.thePlayer.noPhysics) {
-			int blockX = MathHelper.floor_double(mc.thePlayer.x);
-			int blockY = MathHelper.floor_double(mc.thePlayer.y);
-			int blockZ = MathHelper.floor_double(mc.thePlayer.z);
+			int blockX = MathHelper.floor(mc.thePlayer.x);
+			int blockY = MathHelper.floor(mc.thePlayer.y);
+			int blockZ = MathHelper.floor(mc.thePlayer.z);
 
-            TextureRegistry.blockAtlas.bindTexture();
+            TextureRegistry.blockAtlas.bind();
 			
 			int id = mc.theWorld.getBlockId(blockX, blockY, blockZ);
             int meta = mc.theWorld.getBlockMetadata(blockX, blockY, blockZ);
@@ -169,8 +164,7 @@ public class ItemRenderer
 
 		}
 		if(mc.thePlayer.isUnderLiquid(Material.water)) {
-			int k = mc.renderEngine.getTexture("/misc/water.png");
-			glBindTexture(GL_TEXTURE_2D, k);
+            mc.renderEngine.loadTexture("/assets/minecraft/textures/misc/water.png").bind();
 			renderWarpedTextureOverlay(partialTicks);
 		}
 		glEnable(GL_ALPHA_TEST);
@@ -271,15 +265,15 @@ public class ItemRenderer
         }
 
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        GL11.glDisable(3042 /*GL_BLEND*/);
+        GL11.glDisable(GL11.GL_BLEND);
     }
 
     public void updateEquippedItem()
     {
-        prevEquippedProgress = equippedProgress;
-        EntityPlayerSP entityplayersp = mc.thePlayer;
+        oHeight = height;
+        LocalPlayer entityplayersp = mc.thePlayer;
         ItemStack itemstack = entityplayersp.inventory.getCurrentItem();
-        boolean flag = field_20099_f == entityplayersp.inventory.currentItem && itemstack == itemToRender;
+        boolean flag = lastSlot == entityplayersp.inventory.currentItem && itemstack == itemToRender;
         if(itemToRender == null && itemstack == null)
         {
             flag = true;
@@ -291,7 +285,7 @@ public class ItemRenderer
         }
         float f = 0.4F;
         float f1 = flag ? 1.0F : 0.0F;
-        float f2 = f1 - equippedProgress;
+        float f2 = f1 - height;
         if(f2 < -f)
         {
             f2 = -f;
@@ -300,23 +294,23 @@ public class ItemRenderer
         {
             f2 = f;
         }
-        equippedProgress += f2;
-        if(equippedProgress < 0.1F)
+        height += f2;
+        if(height < 0.1F)
         {
             itemToRender = itemstack;
-            field_20099_f = entityplayersp.inventory.currentItem;
+            lastSlot = entityplayersp.inventory.currentItem;
         }
     }
 
     public void resetEquippedProgress()
     {
-        equippedProgress = 0.0F;
+        height = 0.0F;
     }
 
     private final Minecraft mc;
     private ItemStack itemToRender;
-    private float equippedProgress;
-    private float prevEquippedProgress;
+    private float height;
+    private float oHeight;
     public RenderBlocks renderBlocksInstance;
-    private int field_20099_f;
+    private int lastSlot;
 }
diff --git a/src/main/java/net/minecraft/client/render/Lighting.java b/src/main/java/net/minecraft/client/render/Lighting.java
index f9d7d736f..8afaf7acc 100644
--- a/src/main/java/net/minecraft/client/render/Lighting.java
+++ b/src/main/java/net/minecraft/client/render/Lighting.java
@@ -5,7 +5,7 @@ import static org.lwjgl.opengl.GL11.*;
 import java.nio.FloatBuffer;
 
 import net.minecraft.client.GLAllocation;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 
 public class Lighting {
 
@@ -38,20 +38,20 @@ public class Lighting {
 		glEnable(GL_COLOR_MATERIAL);
 		glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
 		
-		Vec3d vec = Vec3d.createVector(0.2D, 1.0D, -0.7D).normalize();
-		glLight(GL_LIGHT0, GL_POSITION, getBuffer(vec.xCoord, vec.yCoord, vec.zCoord, 0.0D));
-		glLight(GL_LIGHT0, GL_DIFFUSE, getBuffer(lightBrightness, lightBrightness, lightBrightness, 1.0F));
-		glLight(GL_LIGHT0, GL_AMBIENT, getBuffer(0.0F, 0.0F, 0.0F, 1.0F));
-		glLight(GL_LIGHT0, GL_SPECULAR, getBuffer(0.0F, 0.0F, 0.0F, 1.0F));
+		Vec3 vec = Vec3.getTempVec3(0.2D, 1.0D, -0.7D).normalize();
+		glLightfv(GL_LIGHT0, GL_POSITION, getBuffer(vec.x, vec.y, vec.z, 0.0D));
+		glLightfv(GL_LIGHT0, GL_DIFFUSE, getBuffer(lightBrightness, lightBrightness, lightBrightness, 1.0F));
+		glLightfv(GL_LIGHT0, GL_AMBIENT, getBuffer(0.0F, 0.0F, 0.0F, 1.0F));
+		glLightfv(GL_LIGHT0, GL_SPECULAR, getBuffer(0.0F, 0.0F, 0.0F, 1.0F));
 		
-		vec = Vec3d.createVector(-0.2D, 1.0D, 0.7D).normalize();
-		glLight(GL_LIGHT1, GL_POSITION, getBuffer(vec.xCoord, vec.yCoord, vec.zCoord, 0.0D));
-		glLight(GL_LIGHT1, GL_DIFFUSE, getBuffer(lightBrightness, lightBrightness, lightBrightness, 1.0F));
-		glLight(GL_LIGHT1, GL_AMBIENT, getBuffer(0.0F, 0.0F, 0.0F, 1.0F));
-		glLight(GL_LIGHT1, GL_SPECULAR, getBuffer(0.0F, 0.0F, 0.0F, 1.0F));
+		vec = Vec3.getTempVec3(-0.2D, 1.0D, 0.7D).normalize();
+		glLightfv(GL_LIGHT1, GL_POSITION, getBuffer(vec.x, vec.y, vec.z, 0.0D));
+		glLightfv(GL_LIGHT1, GL_DIFFUSE, getBuffer(lightBrightness, lightBrightness, lightBrightness, 1.0F));
+		glLightfv(GL_LIGHT1, GL_AMBIENT, getBuffer(0.0F, 0.0F, 0.0F, 1.0F));
+		glLightfv(GL_LIGHT1, GL_SPECULAR, getBuffer(0.0F, 0.0F, 0.0F, 1.0F));
 		
 		glShadeModel(GL_FLAT);
-		glLightModel(GL_LIGHT_MODEL_AMBIENT, getBuffer(ambientBrightness, ambientBrightness, ambientBrightness, 1.0F));
+		glLightModelfv(GL_LIGHT_MODEL_AMBIENT, getBuffer(ambientBrightness, ambientBrightness, ambientBrightness, 1.0F));
 	}
 
 	private static FloatBuffer getBuffer(double d, double d1, double d2, double d3) {
diff --git a/src/main/java/net/minecraft/client/render/LightmapHelper.java b/src/main/java/net/minecraft/client/render/LightmapHelper.java
index 108a009cd..17b446b2b 100644
--- a/src/main/java/net/minecraft/client/render/LightmapHelper.java
+++ b/src/main/java/net/minecraft/client/render/LightmapHelper.java
@@ -43,7 +43,7 @@ public class LightmapHelper {
 		if(mc.gameSettings.customLightmap.value && world != null) {
 			int dimension = world.dimension.id;
 			
-			String path = "/environment/lightmap" + dimension + ".png";
+			String path = "/assets/minecraft/textures/environment/lightmap" + dimension + ".png";
 			
 			System.out.println("Loading lightmap '" + path + "'");
 			customLightmap = mc.renderEngine.getImage(path);
@@ -145,7 +145,7 @@ public class LightmapHelper {
 		glMatrixMode(GL_MODELVIEW);
 
 		// Bind texture
-		mc.renderEngine.bindTexture(lightmapTexture);
+		glBindTexture(GL_TEXTURE_2D, lightmapTexture);
 
 		// Back to default texture
 		glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
diff --git a/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java b/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
index f9a5adeb0..63d489866 100644
--- a/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
+++ b/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
@@ -172,8 +172,7 @@ public class LoadingScreenRenderer
         GL11.glLoadIdentity();
         GL11.glTranslatef(0.0F, 0.0F, -200F);
         Tessellator t = Tessellator.instance;
-        int bgTexture = minecraft.renderEngine.getTexture(backgroundPath);
-        GL11.glBindTexture(GL_TEXTURE_2D, bgTexture);
+        minecraft.renderEngine.loadTexture(backgroundPath).bind();
         float f = 32F;
 
         // Draw background
diff --git a/src/main/java/net/minecraft/client/render/MapItemRenderer.java b/src/main/java/net/minecraft/client/render/MapItemRenderer.java
index 63cc85662..383e6fe05 100644
--- a/src/main/java/net/minecraft/client/render/MapItemRenderer.java
+++ b/src/main/java/net/minecraft/client/render/MapItemRenderer.java
@@ -3,7 +3,8 @@ package net.minecraft.client.render;
 import java.awt.image.BufferedImage;
 import java.util.Iterator;
 
-import org.lwjgl.opengl.GL11;
+import net.minecraft.client.render.texture.BufferedTexture;
+import net.minecraft.core.util.helper.MathHelper;
 
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -12,21 +13,25 @@ import net.minecraft.core.util.helper.Color;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.world.saveddata.maps.ItemMapSavedData;
 import net.minecraft.core.world.saveddata.maps.MapWaypoint;
+import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
 //            RenderEngine, MapData, MapColor, GameSettings, 
-//            Tessellator, MapCoord, FontRenderer, EntityPlayer
+//            Tessellator, MapCoord, FontRenderer, Player
 
 public class MapItemRenderer
 {
+    public static final int IMAGE_WIDTH = 128;
+    public static final int IMAGE_HEIGHT = 128;
+    public static final int IMAGE_AREA = 128 * 128;
 
     public MapItemRenderer(FontRenderer fontrenderer, GameSettings gamesettings, RenderEngine renderengine)
     {
-        mapImageData = new int[16384 /*GL_LIGHT0*/];
+        mapImageData = new int[IMAGE_AREA];
         gameSettings = gamesettings;
         fontRenderer = fontrenderer;
-        mapTexture = renderengine.allocateAndSetupTexture(new BufferedImage(128, 128, 2));
-        for(int i = 0; i < 16384 /*GL_LIGHT0*/; i++)
+        mapTexture = renderengine.loadBufferedTexture(new BufferedImage(128, 128, 2));
+        for(int i = 0; i < IMAGE_AREA; i++)
         {
             mapImageData[i] = 0;
         }
@@ -36,56 +41,58 @@ public class MapItemRenderer
 
     public void renderMap(RenderEngine renderengine, ItemMapSavedData mapdata, float brightness)
     {
-        for(int i = 0; i < 16384 /*GL_LIGHT0*/; i++)
+        for(int i = 0; i < IMAGE_AREA; i++)
         {
-            byte colorIndex = mapdata.colors[i];
+            int colorIndex = mapdata.colors[i];
             //value is divided by 4 to get the map colour id
-            if(colorIndex / 4 == 0)
+            if(colorIndex >> 2 == 0)
             {
                 //if blank, render checkerboard texture
                 mapImageData[i] = (i + i / 128 & 1) * 8 + 16 << 24;
                 continue;
             }
-            int col = MaterialColor.materialColors[colorIndex / 4].col;
-            int i1 = colorIndex & 3;
-            char shade = '\334';
+            int col = MaterialColor.getColorFromIndex(colorIndex >> 2);
+
+            int i1 = colorIndex & 0b11;
+
+            int shade = 220;
             // if higher shade
             if(i1 == 2)
             {
-                shade = '\377';
+                shade = 255;
             }
             // if lower shade
             if(i1 == 0)
             {
-                shade = '\264';
+                shade = 180;
             }
 
 
-            int red = ((col >> 16 & 0xff) * shade) / 255;
-            int green = ((col >> 8 & 0xff) * shade) / 255;
-            int blue = ((col & 0xff) * shade) / 255;
-            mapImageData[i] = 0xff000000 | red << 16 | green << 8 | blue;
+            int red =   (Color.redFromInt(col)   * shade) / 255;
+            int green = (Color.greenFromInt(col) * shade) / 255;
+            int blue =  (Color.blueFromInt(col)  * shade) / 255;
+            mapImageData[i] = Color.intToIntARGB(255, red, green, blue);
         }
 
 
-        renderengine.updateTextureData(mapImageData, 128, 128, mapTexture);
+        renderengine.updateTextureData(mapImageData, 128, 128, mapTexture.id());
         int j = 0;
         int k = 0;
         Tessellator tessellator = Tessellator.instance;
         float f = 0.0F;
         //renders the map
-        GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, mapTexture);
-        GL11.glEnable(3042 /*GL_BLEND*/);
-        GL11.glDisable(3008 /*GL_ALPHA_TEST*/);
+        mapTexture.bind();
+        GL11.glEnable(GL11.GL_BLEND);
+        GL11.glDisable(GL11.GL_ALPHA_TEST);
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV((float)(j + 0) + f, (float)(k + 128) - f, -0.0099999997764825821D, 0.0D, 1.0D);
-        tessellator.addVertexWithUV((float)(j + 128) - f, (float)(k + 128) - f, -0.0099999997764825821D, 1.0D, 1.0D);
-        tessellator.addVertexWithUV((float)(j + 128) - f, (float)(k + 0) + f, -0.0099999997764825821D, 1.0D, 0.0D);
-        tessellator.addVertexWithUV((float)(j + 0) + f, (float)(k + 0) + f, -0.0099999997764825821D, 0.0D, 0.0D);
+        tessellator.addVertexWithUV((float)(j + 0) + f, (float)(k + 128) - f, -0.01D, 0.0D, 1.0D);
+        tessellator.addVertexWithUV((float)(j + 128) - f, (float)(k + 128) - f, -0.01D, 1.0D, 1.0D);
+        tessellator.addVertexWithUV((float)(j + 128) - f, (float)(k + 0) + f, -0.01D, 1.0D, 0.0D);
+        tessellator.addVertexWithUV((float)(j + 0) + f, (float)(k + 0) + f, -0.01D, 0.0D, 0.0D);
         tessellator.draw();
-        GL11.glEnable(3008 /*GL_ALPHA_TEST*/);
-        GL11.glDisable(3042 /*GL_BLEND*/);
-        renderengine.bindTexture(renderengine.getTexture("/misc/mapicons.png"));
+        GL11.glEnable(GL11.GL_ALPHA_TEST);
+        GL11.glDisable(GL11.GL_BLEND);
+        renderengine.bindTexture(renderengine.loadTexture("/assets/minecraft/textures/misc/mapicons.png"));
 
         for(Iterator<MapWaypoint> iterator = mapdata.mapWaypoints.iterator(); iterator.hasNext(); GL11.glPopMatrix())
         {
@@ -108,7 +115,7 @@ public class MapItemRenderer
             tessellator.draw();
         }
         //renders map icons
-        renderengine.bindTexture(renderengine.getTexture("/misc/mapicons.png"));
+        renderengine.bindTexture(renderengine.loadTexture("/assets/minecraft/textures/misc/mapicons.png"));
         for(Iterator<ItemMapSavedData.MapDecoration> iterator = mapdata.decorations.iterator(); iterator.hasNext(); GL11.glPopMatrix())
         {
             ItemMapSavedData.MapDecoration mapcoord = iterator.next();
@@ -135,7 +142,7 @@ public class MapItemRenderer
         }
         GL11.glPushMatrix();
 
-        renderengine.bindTexture(renderengine.getTexture("/misc/flagicon.png"));
+        renderengine.bindTexture(renderengine.loadTexture("/assets/minecraft/textures/misc/flagicon.png"));
         // begin drawing flag colors
         for(Iterator<MapWaypoint> iterator = mapdata.mapWaypoints.iterator(); iterator.hasNext(); GL11.glPopMatrix()) {
             MapWaypoint mapWaypoint = iterator.next();
@@ -176,7 +183,7 @@ public class MapItemRenderer
     }
 
     private final int[] mapImageData;
-    private final int mapTexture;
+    private final BufferedTexture mapTexture;
     private final GameSettings gameSettings;
     private FontRenderer fontRenderer;
 }
diff --git a/src/main/java/net/minecraft/client/render/Polygon.java b/src/main/java/net/minecraft/client/render/Polygon.java
index a6ad40dce..4f0076b48 100644
--- a/src/main/java/net/minecraft/client/render/Polygon.java
+++ b/src/main/java/net/minecraft/client/render/Polygon.java
@@ -1,16 +1,20 @@
 package net.minecraft.client.render;
 
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 
 public class Polygon
 {
+    public Vertex[] vertices;
+    public int vertexCount;
+    public boolean flipNormal;
+
 
     public Polygon(Vertex[] vertices)
     {
-        invertNormal = false;
-        vertexPositions = vertices;
-        nVertices = vertices.length;
+        flipNormal = false;
+        this.vertices = vertices;
+        vertexCount = vertices.length;
     }
 
     public Polygon(Vertex[] vertices, int minU, int minV, int maxU, int maxV, int texWidth, int texHeight)
@@ -18,46 +22,46 @@ public class Polygon
         this(vertices);
         float offsetU = 0.0015625F;
         float offsetV = 0.003125F;
-        vertices[0] = vertices[0].setTexturePosition((float)maxU / texWidth - offsetU, (float)minV / texHeight + offsetV);
-        vertices[1] = vertices[1].setTexturePosition((float)minU / texWidth + offsetU, (float)minV / texHeight + offsetV);
-        vertices[2] = vertices[2].setTexturePosition((float)minU / texWidth + offsetU, (float)maxV / texHeight - offsetV);
-        vertices[3] = vertices[3].setTexturePosition((float)maxU / texWidth - offsetU, (float)maxV / texHeight - offsetV);
+        vertices[0] = vertices[0].remap((float)maxU / texWidth - offsetU, (float)minV / texHeight + offsetV);
+        vertices[1] = vertices[1].remap((float)minU / texWidth + offsetU, (float)minV / texHeight + offsetV);
+        vertices[2] = vertices[2].remap((float)minU / texWidth + offsetU, (float)maxV / texHeight - offsetV);
+        vertices[3] = vertices[3].remap((float)maxU / texWidth - offsetU, (float)maxV / texHeight - offsetV);
     }
 
-    public void flipFace()
+    public void mirror()
     {
-        Vertex[] vertices = new Vertex[vertexPositions.length];
-        for(int i = 0; i < vertexPositions.length; i++)
+        Vertex[] vertices = new Vertex[this.vertices.length];
+        for(int i = 0; i < this.vertices.length; i++)
         {
-            vertices[i] = vertexPositions[vertexPositions.length - i - 1];
+            vertices[i] = this.vertices[this.vertices.length - i - 1];
         }
 
-        vertexPositions = vertices;
+        this.vertices = vertices;
     }
 
-    public void draw(Tessellator tessellator, float scale)
+    public void render(Tessellator tessellator, float scale)
     {
-        Vec3d vec3d = vertexPositions[1].vector3D.subtract(vertexPositions[0].vector3D);
-        Vec3d vec3d1 = vertexPositions[1].vector3D.subtract(vertexPositions[2].vector3D);
-        Vec3d vec3d2 = vec3d1.crossProduct(vec3d).normalize();
+        Vec3 vec3 = vertices[1].pos.vectorTo(vertices[0].pos);
+        Vec3 vec31 = vertices[1].pos.vectorTo(vertices[2].pos);
+        Vec3 vec32 = vec31.crossProduct(vec3).normalize();
         tessellator.startDrawingQuads();
-        if(invertNormal)
+        if(flipNormal)
         {
-            tessellator.setNormal(-(float)vec3d2.xCoord, -(float)vec3d2.yCoord, -(float)vec3d2.zCoord);
+            tessellator.setNormal(-(float) vec32.x, -(float) vec32.y, -(float) vec32.z);
         } else
         {
-            tessellator.setNormal((float)vec3d2.xCoord, (float)vec3d2.yCoord, (float)vec3d2.zCoord);
+            tessellator.setNormal((float) vec32.x, (float) vec32.y, (float) vec32.z);
         }
         for(int i = 0; i < 4; i++)
         {
-            Vertex positiontexturevertex = vertexPositions[i];
-            tessellator.addVertexWithUV((float)positiontexturevertex.vector3D.xCoord * scale, (float)positiontexturevertex.vector3D.yCoord * scale, (float)positiontexturevertex.vector3D.zCoord * scale, positiontexturevertex.texturePositionX, positiontexturevertex.texturePositionY);
+            Vertex positiontexturevertex = vertices[i];
+            tessellator.addVertexWithUV((float)positiontexturevertex.pos.x * scale, (float)positiontexturevertex.pos.y * scale, (float)positiontexturevertex.pos.z * scale, positiontexturevertex.u, positiontexturevertex.v);
         }
 
         tessellator.draw();
     }
-
-    public Vertex[] vertexPositions;
-    public int nVertices;
-    public boolean invertNormal;
+    public Polygon flipNormal() {
+        this.flipNormal = true;
+        return this;
+    }
 }
diff --git a/src/main/java/net/minecraft/client/render/PostProcessingManager.java b/src/main/java/net/minecraft/client/render/PostProcessingManager.java
index ff2cc31ab..85e67a2c7 100644
--- a/src/main/java/net/minecraft/client/render/PostProcessingManager.java
+++ b/src/main/java/net/minecraft/client/render/PostProcessingManager.java
@@ -3,11 +3,10 @@ package net.minecraft.client.render;
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.Dimension;
-import net.minecraft.core.world.biome.Biome;
-import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.type.WorldTypes;
 import net.minecraft.core.world.season.Seasons;
 import net.minecraft.core.world.weather.Weather;
+import net.minecraft.core.world.weather.Weathers;
 
 public class PostProcessingManager
 {
@@ -111,32 +110,32 @@ public class PostProcessingManager
         if (activeWeather != null)
         {
             float intensity = mc.theWorld.weatherManager.getWeatherIntensity() * mc.theWorld.weatherManager.getWeatherIntensity();
-            if (activeWeather == Weather.overworldSnow || activeWeather == Weather.overworldWinterSnow)
+            if (activeWeather == Weathers.OVERWORLD_SNOW || activeWeather == Weathers.OVERWORLD_WINTER_SNOW)
             {
                 contrast += -0.125f * intensity * surfaceness;
                 saturation += -0.25f * intensity * surfaceness;
                 bMod += 0.25f * intensity * surfaceness;
             }
-            else if (activeWeather == Weather.overworldRainBlood)
+            else if (activeWeather == Weathers.OVERWORLD_RAIN_BLOOD)
             {
                 rMod += 0.4f * intensity * surfaceness;
                 gMod += 0.1f * intensity * surfaceness;
                 saturation += 0.125f * intensity * surfaceness;
                 exposure -= 0.125f * intensity * surfaceness;
             }
-            else if (activeWeather == Weather.overworldRain)
+            else if (activeWeather == Weathers.OVERWORLD_RAIN)
             {
                 bMod += 0.1f * intensity * surfaceness;
                 saturation += -0.125f * intensity * surfaceness;
                 brightness += -0.0625f * intensity * surfaceness;
             }
-            else if (activeWeather == Weather.overworldStorm)
+            else if (activeWeather == Weathers.OVERWORLD_STORM)
             {
                 bMod += 0.1f * intensity * surfaceness;
                 saturation += -0.2f * intensity * surfaceness;
                 brightness += -0.1f * intensity * surfaceness;
             }
-            else if (activeWeather == Weather.overworldFog && mc.gameSettings.fog.value)
+            else if (activeWeather == Weathers.OVERWORLD_FOG && mc.gameSettings.fog.value)
             {
                 saturation += -0.4f * intensity * surfaceness;
                 contrast += -0.25f * intensity * surfaceness;
diff --git a/src/main/java/net/minecraft/client/render/RenderBlockCache.java b/src/main/java/net/minecraft/client/render/RenderBlockCache.java
index 2f5b87f33..e700d2b2c 100644
--- a/src/main/java/net/minecraft/client/render/RenderBlockCache.java
+++ b/src/main/java/net/minecraft/client/render/RenderBlockCache.java
@@ -4,6 +4,7 @@ import java.util.Arrays;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.WorldSource;
 
 final public class RenderBlockCache {
diff --git a/src/main/java/net/minecraft/client/render/RenderBlocks.java b/src/main/java/net/minecraft/client/render/RenderBlocks.java
index 44d6a01db..7423d47e6 100644
--- a/src/main/java/net/minecraft/client/render/RenderBlocks.java
+++ b/src/main/java/net/minecraft/client/render/RenderBlocks.java
@@ -5,7 +5,7 @@ import org.lwjgl.opengl.GL11;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.block.model.BlockModel;
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.enums.LightLayer;
@@ -13,11 +13,11 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
 // Referenced classes of package net.minecraft.src:
-//            Block, BlockRail, Tessellator, IBlockAccess,
-//            BlockBed, ModelBed, BlockRedstoneRepeater, BlockPistonBase, 
-//            BlockPistonExtension, Vec3D, BlockFire, BlockRedstoneWire, 
-//            EntityRenderer, BlockFluid, MathHelper, Material, 
-//            BlockDoor, World
+//            Block, RailBlock, Tessellator, IBlockAccess,
+//            BedBlock, ModelBed, RepeaterBlock, BasePistonBlock,
+//            BlockPistonExtension, Vec3D, FireBlock, RedstoneWireBlock,
+//            EntityRenderer, FluidBlock, MathHelper, Material,
+//            DoorBlock, World
 
 public class RenderBlocks
 {
